.386
.MODEL FLAT

.CODE
_run:

; **************************************************************************************

include         stdparas.inc                            ; PA1-PA4
include         abpstruc.inc                            ; asmBmpPara-structure

asmBmpPara      EQU     <PA1>

; **************************************************************************************

Emboss          PROC    NEAR

init:           mac     SAVE
                mov     ebx,asmBmpPara

                mov     esi,srcBits                     ; copy org
                mov     edi,tgtBits
                mov     ecx,tgtWidth
                imul    ecx,tgtHeight
                rep     movsd

                mov     ecx,PA2                         ; calculate offset
                and     cl,7
                xor     eax,eax
                cdq
                mov     ebp,eax                         ; (!)
                inc     eax
                shl     al,cl                
                test    al,0DDh
                jz      init_1
                mov     dl,4
                test    al,0C1h
                jz      init_1
                neg     edx
init_1:         test    al,77h
                jz      init_2
                mov     ebp,srcWidthBytes
                test    al,7
                jz      init_2
                neg     ebp
init_2:         add     ebp,edx
                                                                
                mov     esi,srcWidth                    ; initialize loop
                mov     ecx,esi
                dec     ecx
                dec     ecx
                jle     finish                          ; return 0
                mov     edx,srcHeight
                dec     edx
                dec     edx
                jle     finish                          ; return 0

                inc     esi                             ; point to buffers
                shl     esi,2
                mov     edi,esi
                add     esi,srcBits
                add     edi,tgtBits

                mov     eax,srcWidthBytes
                mov     ebx,ebp
                neg     ebx

row_loop:       push    eax                             ; change pixels
                push    ecx
                push    esi
                push    edi

col_loop:       movzx   eax,Byte Ptr [esi+ebp]
                sub     al,[esi+ebx] 
                adc     ah,255
                and     al,ah
                add     al,127
                sbb     ah,ah
                or      al,ah
                mov     [edi],al
                inc     edi
                inc     esi
                test    esi,3
                jpo     col_loop

                inc     esi
                inc     edi
                dec     ecx
                jnz     col_loop
                
                pop     edi
                pop     esi
                pop     ecx
                pop     eax
                add     edi,eax
                add     esi,eax
                dec     edx
                jnz     row_loop

finish:         stc
                mac     REST

Emboss          ENDP

END _run
