Attribute VB_Name = "asm_Emboss"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' asmEmboss
'
' CALL          asmEmboss(ptr:lpAsmBmpPara, [fct:factor])
'
' IN:           lng:ptr Points to asmBmpPara-structure
'               lng:fct 0 to 7           (default = 1)
'
' OUT:          bol     success
'
Function asmEmboss(lpAsmBmpPara As Long, Optional fct As Long = 10) As Boolean
    
    Static asm(40) As Long
    
    If asm(0) = 0 Then
        asm(0) = &HEC8B5590:        asm(1) = &H8B575653
        asm(2) = &H738B085D:        asm(3) = &H2C7B8B14
        asm(4) = &HF1C4B8B:         asm(5) = &HF3204BAF
        asm(6) = &HC4D8BA5:         asm(7) = &H3307E180
        asm(8) = &HE88B99C0:        asm(9) = &HA8E0D240
        asm(10) = &HB20874DD:       asm(11) = &H74C1A804
        asm(12) = &HA8DAF702:       asm(13) = &H8B097477
        asm(14) = &H7A80C6B:        asm(15) = &HDDF70274
        asm(16) = &H738BEA03:       asm(17) = &H49CE8B04
        asm(18) = &H8B4D7E49:       asm(19) = &H4A4A0853
        asm(20) = &HC146467E:       asm(21) = &HFE8B02E6
        asm(22) = &H3147303:        asm(23) = &H438B2C7B
        asm(24) = &HF7DD8B0C:       asm(25) = &H565150DB
        asm(26) = &H44B60F57:       asm(27) = &H42A0035
        asm(28) = &HFFD48033:       asm(29) = &H7F04C422
        asm(30) = &HC40AE41A:       asm(31) = &H46470788
        asm(32) = &H3C6F7:          asm(33) = &HE17B0000
        asm(34) = &H75494746:       asm(35) = &H595E5FDC
        asm(36) = &H3F80358:        asm(37) = &HCD754AF0
        asm(38) = &H5FC01BF9:       asm(39) = &HC25D5B5E
        asm(40) = &H10
    End If
    ' ************************************************************
    
    asmEmboss = CallWindowProc(asm(0), lpAsmBmpPara, fct, 0, 0)
End Function

' basEmboss
'
' AUFRUF:       basEmboss(src, tgt, [fct:Faktor])
'
' EIN:          bar:src Herkunftsdaten (ByteArray)
'               bar:tgt Zieldaten      (ByteArray)
'               lng:fct Faktor 0-7     (Vorgabe 1)
'               log:bw  Schwarz/Wei   (Vorgabe nein)
'
' AUS:          log     Erfolg
'
Function basEmboss(src() As Byte, tgt() As Byte, Optional fct As Long = 1) _
    As Boolean
    
    Dim X1      As Long
    Dim Y1      As Long
    Dim N1      As Long
    Dim DX1     As Long
    Dim DY1     As Long
    Dim DX2     As Long
    Dim DY2     As Long
    
    N1 = (fct And 7) + 1
    DX1 = Choose(N1, -4, 0, 4, 4, 4, 0, -4, -4)
    DX2 = -DX1
    DY1 = Choose(N1, -1, -1, -1, 0, 1, 1, 1, 0)
    DY2 = -DY1
    
    CopyMemory tgt(1, 1), src(1, 1), UBound(src, 1) * UBound(src, 2)
    
    For X1 = 5 To UBound(src, 1) - 7
        X1 = X1 - ((X1 And 3) = 0)
        
        For Y1 = 2 To UBound(src, 2) - 1
            N1 = 0& - src(X1 + DX1, Y1 + DY1) + src(X1 + DX2, Y1 + DY2) + 127
            
            If N1 < 127 Then N1 = 127
            If N1 > 255 Then N1 = 255
            
            tgt(X1, Y1) = N1
        Next Y1
    Next X1
    
    basEmboss = True
End Function
